/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * Config.java
 *
 * Created on 25-dic-2011, 16:44:11
 */
package jmednafen;

import java.awt.GridLayout;
import java.io.*;
import java.util.ArrayList;
import java.util.Collections;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;

/**
 *
 * @author moises
 */
public class Config extends javax.swing.JFrame {
    private String home_path;
    private String config_path;
    private String audio_path;
    private String video_path;
    private String other_path;
    private String ingame_path;
    private String control_path;
    private String network_path;
    private String temp_path;
    private InternalConfiguration configuration;
    private OptionContainer audio_options;
    private OptionContainer video_options;
    private OptionContainer other_options;
    private OptionContainer ingame_options;
    private OptionContainer control_options;
    private OptionContainer network_options;
    private PluginInfoViewer info_viewer;
    private ArrayList<String> audio_plugins;
    private ArrayList<String> video_plugins;
    private ArrayList<String> other_plugins;
    private ArrayList<String> control_plugins;
    private ArrayList<String> network_plugins;
    private ArrayList<String> ingame_plugins;
    private boolean can_reload_plugin_list;
    private boolean must_load_video = true;
    private boolean must_load_audio = true;
    private boolean must_load_other = true;
    private boolean must_load_control = true;
    private boolean must_load_network = true;
    private boolean must_load_ingame = true;
    private boolean must_load_internal_config = true;
    private boolean just_reseting = false;
    
    /** Creates new form Config */
    public Config ()
    {
        can_reload_plugin_list = false;
        initComponents();
        panel_video.setLayout ( new GridLayout ( 0 , 1 ) );
        panel_audio.setLayout ( new GridLayout ( 0 , 1 ) );
        panel_other.setLayout ( new GridLayout ( 0 , 1 ) );
        panel_ingame.setLayout ( new GridLayout ( 0 , 1 ) );
        panel_controls.setLayout ( new GridLayout ( 0 , 1 ) );
        panel_network.setLayout ( new GridLayout ( 0 , 1 ) );
        audio_options = new OptionContainer ();
        video_options = new OptionContainer ();
        other_options = new OptionContainer ();
        control_options = new OptionContainer ();
        ingame_options = new OptionContainer ();
        network_options = new OptionContainer ();
        info_viewer = new PluginInfoViewer ();
        audio_plugins = new ArrayList<String> ();
        video_plugins = new ArrayList<String> ();
        control_plugins = new ArrayList<String> ();
        other_plugins = new ArrayList<String> ();
        network_plugins = new ArrayList<String> ();
        ingame_plugins = new ArrayList<String> ();
        fullReset ();
    }
    
    private void fullReset ()
    {
        loadConfig ();
        loadPluginList ();
        can_reload_plugin_list = true;
        must_load_video = false;
        must_load_audio = false;
        must_load_other = false;
        must_load_control = false;
        must_load_ingame = false;
        must_load_network = false;
        must_load_internal_config = false;
    }
    
    public int getCommandFormat ()
    {
        return ( combobox_command_format.getSelectedIndex () );
    }
    
    private void scanForPlugins ( String path , ArrayList<String> list )
    {
        File folder;
        
        folder = new File ( path );
        
        if ( folder.isDirectory () )
        {
            File[] names = folder.listFiles ();
            
            for ( int i = 0; i < names.length; i++ )
            {
                if ( names[ i ].isFile () )
                {
                    if ( names[ i ].getName ().toUpperCase ().endsWith ( ".CFG" ) )
                    {
                        list.add ( names[ i ].getName () );
                    }
                }
            }
            
            if ( names.length == 0 )
            {
                list.add ( "None plugin" );
            }
        }
    }
    
    private void insertListInCombo ( ArrayList<String> list , JComboBox combo , String active_plugin )
    {
        combo.removeAllItems ();
        int active = 0;
        
        Collections.sort ( list );
        
        for ( int i = 0; i < list.size (); i++ )
        {
            combo.addItem ( list.get ( i ) );
            if ( list.get ( i ).equals ( active_plugin ) )
            {
                active = i;
            }
        }
        
        combo.setSelectedIndex ( active );
    }
    
    private void loadPluginList ()
    {
        scanForPlugins ( audio_path , audio_plugins );
        scanForPlugins ( video_path , video_plugins );
        scanForPlugins ( other_path , other_plugins );
        scanForPlugins ( network_path , network_plugins );
        scanForPlugins ( control_path , control_plugins );
        scanForPlugins ( ingame_path , ingame_plugins );
        
        insertListInCombo ( audio_plugins , combobox_audio , configuration.getAudioPluginPath () );
        insertListInCombo ( video_plugins , combobox_video , configuration.getVideoPluginPath () );
        insertListInCombo ( control_plugins , combobox_controls , configuration.getControlPluginPath () );
        insertListInCombo ( other_plugins , combobox_other , configuration.getOtherPluginPath () );
        insertListInCombo ( network_plugins , combobox_network , configuration.getNetworkPluginPath () );
        insertListInCombo ( ingame_plugins , combobox_ingame , configuration.getInGamePluginPath () );
    }
    
    public InternalConfiguration getInternalConfiguration ()
    {
        return ( configuration );
    }
    
    public String getTempPath ()
    {
        return ( temp_path + configuration.getTempFile () );
    }
    
    public ArrayList<String> getCommandOptions ()
    {
        ArrayList<String> command_options = new ArrayList<String> ();
        
        for ( int i = 0; i < audio_options.getRows ().size (); i++ )
        {
            command_options.add ( audio_options.getRows ().get ( i ).getCommand () );
        }
        
        for ( int i = 0; i < video_options.getRows ().size (); i++ )
        {
            command_options.add ( video_options.getRows ().get ( i ).getCommand () );
        }
        
        for ( int i = 0; i < other_options.getRows ().size (); i++ )
        {
            command_options.add ( other_options.getRows ().get ( i ).getCommand () );
        }
        
        for ( int i = 0; i < ingame_options.getRows ().size (); i++ )
        {
            command_options.add ( ingame_options.getRows ().get ( i ).getCommand () );
        }
        
        for ( int i = 0; i < control_options.getRows ().size (); i++ )
        {
            command_options.add ( control_options.getRows ().get ( i ).getCommand () );
        }
        
        for ( int i = 0; i < network_options.getRows ().size (); i++ )
        {
            command_options.add ( network_options.getRows ().get ( i ).getCommand () );
        }
        
        return ( command_options );
    }
    
    private boolean createFolder ( String path )
    {
        File folder;
        folder = new File ( path );
        if ( !folder.isDirectory () )
        {
            try
            {
                folder.mkdirs ();
            }
            catch ( SecurityException e )
            {
                System.out.println ( "Error trying to create folder: " + path );
                System.out.println ( "Error: " + e.getMessage () );
                
                return ( false );
            }
        }
        return ( true );
    }
    
    private void showExtentions ()
    {
        combobox_extentions.removeAllItems ();
        for ( int i = 0; i < configuration.getExtentions ().length; i++ )
        {
            combobox_extentions.addItem ( configuration.getExtentions ()[ i ] );
        }
    }
    
    private void showOptions ()
    {
        if ( !just_reseting )
        {
            if ( video_options.getRows ().size () < 12 )
            {
                for ( int i = video_options.getRows ().size (); i < 12; i++ )
                {
                    video_options.getRows ().add( ConfigRow.createSeparator () );
                }
            }
            for ( int i = 0; i < video_options.getRows ().size (); i++ )
            {
                video_options.getRows ().get ( i ).config ();
                panel_video.add ( video_options.getRows ().get ( i ) );
                panel_video.revalidate ();
            }

            if ( audio_options.getRows ().size () < 12 )
            {
                for ( int i = audio_options.getRows ().size (); i < 12; i++ )
                {
                    audio_options.getRows ().add( ConfigRow.createSeparator () );
                }
            }
            for ( int i = 0; i < audio_options.getRows ().size (); i++ )
            {
                audio_options.getRows ().get ( i ).config ();
                panel_audio.add ( audio_options.getRows ().get ( i ) );
                panel_audio.revalidate ();
            }

            if ( other_options.getRows ().size () < 12 )
            {
                for ( int i = other_options.getRows ().size (); i < 12; i++ )
                {
                    other_options.getRows ().add( ConfigRow.createSeparator () );
                }
            }
            for ( int i = 0; i < other_options.getRows ().size (); i++ )
            {
                other_options.getRows ().get ( i ).config ();
                panel_other.add ( other_options.getRows ().get ( i ) );
                panel_video.revalidate ();
            }

            if ( control_options.getRows ().size () < 12 )
            {
                for ( int i = control_options.getRows ().size (); i < 12; i++ )
                {
                    control_options.getRows ().add( ConfigRow.createSeparator () );
                }
            }
            for ( int i = 0; i < control_options.getRows ().size (); i++ )
            {
                control_options.getRows ().get ( i ).config ();
                panel_controls.add ( control_options.getRows ().get ( i ) );
                panel_controls.revalidate ();
            }

            if ( ingame_options.getRows ().size () < 12 )
            {
                for ( int i = ingame_options.getRows ().size (); i < 12; i++ )
                {
                    ingame_options.getRows ().add( ConfigRow.createSeparator () );
                }
            }
            for ( int i = 0; i < ingame_options.getRows ().size (); i++ )
            {
                ingame_options.getRows ().get ( i ).config ();
                panel_ingame.add ( ingame_options.getRows ().get ( i ) );
                panel_ingame.revalidate ();
            }

            if ( network_options.getRows ().size () < 12 )
            {
                for ( int i = network_options.getRows ().size (); i < 12; i++ )
                {
                    network_options.getRows ().add( ConfigRow.createSeparator () );
                }
            }
            for ( int i = 0; i < network_options.getRows ().size (); i++ )
            {
                network_options.getRows ().get ( i ).config ();
                panel_network.add ( network_options.getRows ().get ( i ) );
                panel_network.revalidate ();
            }

            validate ();
        }
        
        combobox_command_format.setSelectedIndex ( configuration.getCommandFormat () );
        textfield_binary_path.setText ( configuration.getMednafenPath () );
        showExtentions ();
    }
    
    private void loadConfig ()
    {
        home_path = System.getProperty ( "user.home" );
        
        if ( !home_path.endsWith ( File.separator ) )
        {
            home_path += File.separator;
        }
        
        config_path = home_path + ".tuxmansoft" + File.separator + "JMednafen" + File.separator + "0.2.2" + File.separator;
        
        System.out.println ( "Config folder: " + config_path );
        
        if ( !createFolder ( config_path ) )
        {
            return;
        }
        
        if ( must_load_internal_config )
        {
            configuration = FileLoader.loadInternalConfiguration ( config_path + "main.cfg" );
        }
        
        System.out.println ( "Audio plugin path: " + configuration.getAudioPluginPath () );
        System.out.println ( "Video plugin path: " + configuration.getVideoPluginPath () );
        System.out.println ( "Other plugin path: " + configuration.getOtherPluginPath () );
        System.out.println ( "Control plugin path: " + configuration.getControlPluginPath () );
        System.out.println ( "In-Game plugin path: " + configuration.getInGamePluginPath () );
        System.out.println ( "Network plugin path: " + configuration.getNetworkPluginPath () );
        
        audio_path = config_path + "audio" + File.separator;
        video_path = config_path + "video" + File.separator;
        other_path = config_path + "other" + File.separator;
        control_path = config_path + "control" + File.separator;
        ingame_path = config_path + "ingame" + File.separator;
        network_path = config_path + "network" + File.separator;
        temp_path = config_path;
        
        if ( !createFolder ( audio_path ) ||
             !createFolder ( video_path ) ||
             !createFolder ( control_path ) ||
             !createFolder ( ingame_path ) ||
             !createFolder ( network_path ) ||
             !createFolder ( other_path )
           )
        {
            return;
        }
        
        if ( must_load_audio )
        {
            FileCreator.checkDefaultAudioPlugins ( audio_path );
            audio_options = FileLoader.loadPluginFile (
                                                        audio_path + configuration.getAudioPluginPath () ,
                                                        FileLoader.AUDIO
                                                      );
            FileLoader.loadStoredValues( audio_path + configuration.getAudioPluginPath () , audio_options.getRows () , FileLoader.AUDIO );
            panel_audio.removeAll ();
        }
        
        if ( must_load_video )
        {
            FileCreator.checkDefaultVideoPlugins ( video_path );
            video_options = FileLoader.loadPluginFile (
                                                        video_path + configuration.getVideoPluginPath () ,
                                                        FileLoader.VIDEO
                                                      );
            FileLoader.loadStoredValues( video_path + configuration.getVideoPluginPath () , video_options.getRows () , FileLoader.VIDEO );
            panel_video.removeAll ();
        }
        
        if ( must_load_other )
        {
            FileCreator.checkDefaultOtherPlugins ( other_path );
            other_options = FileLoader.loadPluginFile (
                                                        other_path + configuration.getOtherPluginPath () ,
                                                        FileLoader.OTHER
                                                      );
            FileLoader.loadStoredValues( other_path + configuration.getOtherPluginPath () , other_options.getRows () , FileLoader.OTHER );
            panel_other.removeAll ();
        }
        
        if ( must_load_control )
        {
            FileCreator.checkDefaultControlsPlugins ( control_path );
            control_options = FileLoader.loadPluginFile (
                                                          control_path + configuration.getControlPluginPath () ,
                                                          FileLoader.CONTROL
                                                        );
            FileLoader.loadStoredValues( control_path + configuration.getControlPluginPath () , control_options.getRows () , FileLoader.CONTROL );
            panel_controls.removeAll ();
        }
        
        if ( must_load_ingame )
        {
            FileCreator.checkDefaultInGamePlugins ( ingame_path );
            ingame_options = FileLoader.loadPluginFile (
                                                         ingame_path + configuration.getInGamePluginPath () ,
                                                         FileLoader.INGAME
                                                       );
            FileLoader.loadStoredValues( ingame_path + configuration.getInGamePluginPath () , ingame_options.getRows () , FileLoader.INGAME );
            panel_ingame.removeAll ();
        }
        
        if ( must_load_network )
        {
            FileCreator.checkDefaultNetworkPlugins ( network_path );
            network_options = FileLoader.loadPluginFile (
                                                          network_path + configuration.getNetworkPluginPath () ,
                                                          FileLoader.NETWORK
                                                        );
            FileLoader.loadStoredValues( network_path + configuration.getNetworkPluginPath () , network_options.getRows () , FileLoader.NETWORK );
            panel_network.removeAll ();
        }
        
        showOptions ();
    }
    
    private void saveOptions ()
    {
        FileCreator.createStoredValuesFile ( video_path + configuration.getVideoPluginPath () , video_options.getRows () , FileCreator.SAVE );
        FileCreator.createStoredValuesFile ( audio_path + configuration.getAudioPluginPath () , audio_options.getRows () , FileCreator.SAVE );
        FileCreator.createStoredValuesFile ( other_path + configuration.getOtherPluginPath () , other_options.getRows () , FileCreator.SAVE );
        FileCreator.createStoredValuesFile ( network_path + configuration.getNetworkPluginPath () , network_options.getRows () , FileCreator.SAVE );
        FileCreator.createStoredValuesFile ( control_path + configuration.getControlPluginPath () , control_options.getRows () , FileCreator.SAVE );
        FileCreator.createStoredValuesFile ( ingame_path + configuration.getInGamePluginPath () , ingame_options.getRows () , FileCreator.SAVE );
        
        configuration.setCommandFormat ( combobox_command_format.getSelectedIndex () );
        configuration.setMednafenPath ( textfield_binary_path.getText () );
        
        FileCreator.createInternalConfiguration( config_path + "main.cfg" , FileCreator.SAVE , configuration );
    }
    
    public void closeAll ()
    {
        info_viewer.setVisible ( false );
        info_viewer.dispose ();
    }
    
    private boolean copyFile ( String srFile , String dtFile )
    {
        try
        {
            File f1 = new File ( srFile );
            File f2 = new File ( dtFile );
            InputStream in = new FileInputStream ( f1 );
            
            OutputStream out = new FileOutputStream ( f2 );

            byte[] buf = new byte[ 1024 ];
            int len;
            
            while ( ( len = in.read ( buf ) ) > 0 )
            {
                out.write ( buf , 0 , len );
            }
            
            in.close ();
            out.close ();
        }
        catch ( FileNotFoundException ex )
        {
            return ( false );
        }
        catch ( IOException e )
        {
            return ( false );
        }
        
        return ( true );
    }
    
    private void installNewPlugins ()
    {
        String[] plugins = { "Audio", "Video", "Controls" , "In-Game" , "Network" , "Other" };
        String plugin_to_install = (String)JOptionPane.showInputDialog ( this ,
                                                                         "Wich type of plugin to install?" ,
                                                                         "Plugin installation" , 
                                                                         JOptionPane.QUESTION_MESSAGE , 
                                                                         null ,
                                                                         plugins ,
                                                                         plugins[ 0 ]
                                                                       );
        
        if ( plugin_to_install == null )
        {
            return;
        }
        
        JFileChooser plugin_chooser = new JFileChooser ();
        plugin_chooser.setFileFilter ( new FileNameExtensionFilter ( "JMednafen plugin files" , "cfg" ) );
        plugin_chooser.setDialogTitle ( "JMednafen - Select plugin to install" );
        
        int value;
        value = plugin_chooser.showOpenDialog ( this );
        
        if ( value == JFileChooser.APPROVE_OPTION )
        {
            String file_to_install = plugin_chooser.getSelectedFile ().getAbsolutePath ();
            String destination_name;
            
            if ( plugin_to_install.equals ( "Video" ) )
            {
                destination_name = video_path;
            }
            else if ( plugin_to_install.equals ( "Audio" ) )
            {
                destination_name = audio_path;
            }
            else if ( plugin_to_install.equals ( "Network" ) )
            {
                destination_name = network_path;
            }
            else if ( plugin_to_install.equals ( "Controls" ) )
            {
                destination_name = control_path;
            }
            else if ( plugin_to_install.equals ( "In-Game" ) )
            {
                destination_name = ingame_path;
            }
            else
            {
                destination_name = other_path;
            }

            destination_name += plugin_chooser.getSelectedFile ().getName ();
            
            System.out.println ( "Plugin type to install: " + plugin_to_install );
            System.out.println ( "File to install: " + file_to_install );
            System.out.println ( "Destination file: " + destination_name );
            
            if ( !copyFile ( file_to_install , destination_name ) )
            {
                JOptionPane.showMessageDialog ( this , "Error installing plugin. Try again or restart JMednafen" , "Error installing plugin" , JOptionPane.ERROR_MESSAGE );
            }
            else
            {
                JOptionPane.showMessageDialog ( this , "Plugin installed. Restart JMednafen to detect the new plugin." , "Plugin installed" , JOptionPane.INFORMATION_MESSAGE );
            }
        }
    }
    
    private void showInfo ( OptionContainer options , String section )
    {
        info_viewer.setAuthor ( options.getAuthor () );
        info_viewer.setDescription ( options.getDescription () );
        info_viewer.setVersion ( options.getVersion () );
        info_viewer.setSection ( section );
        info_viewer.setVisible ( true );
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jPanel4 = new javax.swing.JPanel();
        jPanel11 = new javax.swing.JPanel();
        jComboBox7 = new javax.swing.JComboBox();
        jButton13 = new javax.swing.JButton();
        label_icon = new javax.swing.JLabel();
        label_title = new javax.swing.JLabel();
        button_close = new javax.swing.JButton();
        button_save = new javax.swing.JButton();
        tabbedpanel_plugins = new javax.swing.JTabbedPane();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        panel_video = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        panel_audio = new javax.swing.JPanel();
        jPanel6 = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        panel_controls = new javax.swing.JPanel();
        jPanel7 = new javax.swing.JPanel();
        jScrollPane5 = new javax.swing.JScrollPane();
        panel_ingame = new javax.swing.JPanel();
        jPanel8 = new javax.swing.JPanel();
        jScrollPane6 = new javax.swing.JScrollPane();
        panel_network = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        panel_other = new javax.swing.JPanel();
        jPanel9 = new javax.swing.JPanel();
        label_binary_path = new javax.swing.JLabel();
        textfield_binary_path = new javax.swing.JTextField();
        plugins_panel = new javax.swing.JPanel();
        label_title_video = new javax.swing.JLabel();
        label_title_audio = new javax.swing.JLabel();
        label_title_controls = new javax.swing.JLabel();
        label_title_ingame = new javax.swing.JLabel();
        label_title_other = new javax.swing.JLabel();
        label_title_network = new javax.swing.JLabel();
        combobox_video = new javax.swing.JComboBox();
        combobox_audio = new javax.swing.JComboBox();
        combobox_controls = new javax.swing.JComboBox();
        combobox_ingame = new javax.swing.JComboBox();
        combobox_network = new javax.swing.JComboBox();
        combobox_other = new javax.swing.JComboBox();
        button_info_video = new javax.swing.JButton();
        button_info_audio = new javax.swing.JButton();
        button_info_controls = new javax.swing.JButton();
        button_info_ingame = new javax.swing.JButton();
        button_info_network = new javax.swing.JButton();
        button_info_other = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        combobox_command_format = new javax.swing.JComboBox();
        button_help_command_format = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        button_add_extention = new javax.swing.JButton();
        combobox_extentions = new javax.swing.JComboBox();
        button_reload = new javax.swing.JButton();
        button_reset = new javax.swing.JButton();
        button_install_new_plugins = new javax.swing.JButton();

        jLabel1.setText("jLabel1");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout jPanel11Layout = new javax.swing.GroupLayout(jPanel11);
        jPanel11.setLayout(jPanel11Layout);
        jPanel11Layout.setHorizontalGroup(
            jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );
        jPanel11Layout.setVerticalGroup(
            jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 100, Short.MAX_VALUE)
        );

        jComboBox7.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        jButton13.setText("jButton13");

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("JMednafen - Config");
        setResizable(false);

        label_icon.setIcon(new javax.swing.ImageIcon(getClass().getResource("/jmednafen/jmednafen-icon-64x64.png"))); // NOI18N

        label_title.setFont(new java.awt.Font("Dialog", 1, 14)); // NOI18N
        label_title.setText("JMednafen configuration window");

        button_close.setText("Close");
        button_close.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button_closeActionPerformed(evt);
            }
        });

        button_save.setText("Save");
        button_save.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button_saveActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout panel_videoLayout = new javax.swing.GroupLayout(panel_video);
        panel_video.setLayout(panel_videoLayout);
        panel_videoLayout.setHorizontalGroup(
            panel_videoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 1039, Short.MAX_VALUE)
        );
        panel_videoLayout.setVerticalGroup(
            panel_videoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 326, Short.MAX_VALUE)
        );

        jScrollPane1.setViewportView(panel_video);

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 1050, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 323, Short.MAX_VALUE)
                .addContainerGap())
        );

        tabbedpanel_plugins.addTab("Video", jPanel2);

        javax.swing.GroupLayout panel_audioLayout = new javax.swing.GroupLayout(panel_audio);
        panel_audio.setLayout(panel_audioLayout);
        panel_audioLayout.setHorizontalGroup(
            panel_audioLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 1039, Short.MAX_VALUE)
        );
        panel_audioLayout.setVerticalGroup(
            panel_audioLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 326, Short.MAX_VALUE)
        );

        jScrollPane2.setViewportView(panel_audio);

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 1050, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 323, Short.MAX_VALUE)
                .addContainerGap())
        );

        tabbedpanel_plugins.addTab("Audio", jPanel3);

        javax.swing.GroupLayout panel_controlsLayout = new javax.swing.GroupLayout(panel_controls);
        panel_controls.setLayout(panel_controlsLayout);
        panel_controlsLayout.setHorizontalGroup(
            panel_controlsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 1039, Short.MAX_VALUE)
        );
        panel_controlsLayout.setVerticalGroup(
            panel_controlsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 326, Short.MAX_VALUE)
        );

        jScrollPane4.setViewportView(panel_controls);

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 1050, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 323, Short.MAX_VALUE)
                .addContainerGap())
        );

        tabbedpanel_plugins.addTab("Controls", jPanel6);

        javax.swing.GroupLayout panel_ingameLayout = new javax.swing.GroupLayout(panel_ingame);
        panel_ingame.setLayout(panel_ingameLayout);
        panel_ingameLayout.setHorizontalGroup(
            panel_ingameLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 1039, Short.MAX_VALUE)
        );
        panel_ingameLayout.setVerticalGroup(
            panel_ingameLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 326, Short.MAX_VALUE)
        );

        jScrollPane5.setViewportView(panel_ingame);

        javax.swing.GroupLayout jPanel7Layout = new javax.swing.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane5, javax.swing.GroupLayout.DEFAULT_SIZE, 1050, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane5, javax.swing.GroupLayout.DEFAULT_SIZE, 323, Short.MAX_VALUE)
                .addContainerGap())
        );

        tabbedpanel_plugins.addTab("In-Game", jPanel7);

        javax.swing.GroupLayout panel_networkLayout = new javax.swing.GroupLayout(panel_network);
        panel_network.setLayout(panel_networkLayout);
        panel_networkLayout.setHorizontalGroup(
            panel_networkLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 1039, Short.MAX_VALUE)
        );
        panel_networkLayout.setVerticalGroup(
            panel_networkLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 326, Short.MAX_VALUE)
        );

        jScrollPane6.setViewportView(panel_network);

        javax.swing.GroupLayout jPanel8Layout = new javax.swing.GroupLayout(jPanel8);
        jPanel8.setLayout(jPanel8Layout);
        jPanel8Layout.setHorizontalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane6, javax.swing.GroupLayout.DEFAULT_SIZE, 1050, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel8Layout.setVerticalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane6, javax.swing.GroupLayout.DEFAULT_SIZE, 323, Short.MAX_VALUE)
                .addContainerGap())
        );

        tabbedpanel_plugins.addTab("Network", jPanel8);

        javax.swing.GroupLayout panel_otherLayout = new javax.swing.GroupLayout(panel_other);
        panel_other.setLayout(panel_otherLayout);
        panel_otherLayout.setHorizontalGroup(
            panel_otherLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 1039, Short.MAX_VALUE)
        );
        panel_otherLayout.setVerticalGroup(
            panel_otherLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 326, Short.MAX_VALUE)
        );

        jScrollPane3.setViewportView(panel_other);

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 1050, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 323, Short.MAX_VALUE)
                .addContainerGap())
        );

        tabbedpanel_plugins.addTab("Other", jPanel5);

        label_binary_path.setText("Mednafen binary path:");

        textfield_binary_path.setText("...");

        plugins_panel.setBorder(javax.swing.BorderFactory.createTitledBorder("Plugins"));

        label_title_video.setText("Video:");

        label_title_audio.setText("Audio:");

        label_title_controls.setText("Controls:");

        label_title_ingame.setText("In-Game:");

        label_title_other.setText("Other:");

        label_title_network.setText("Network:");

        combobox_video.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        combobox_video.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                combobox_videoItemStateChanged(evt);
            }
        });

        combobox_audio.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        combobox_audio.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                combobox_audioItemStateChanged(evt);
            }
        });

        combobox_controls.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        combobox_controls.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                combobox_controlsItemStateChanged(evt);
            }
        });

        combobox_ingame.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        combobox_ingame.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                combobox_ingameItemStateChanged(evt);
            }
        });

        combobox_network.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        combobox_network.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                combobox_networkItemStateChanged(evt);
            }
        });

        combobox_other.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        combobox_other.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                combobox_otherItemStateChanged(evt);
            }
        });

        button_info_video.setText("View info");
        button_info_video.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button_info_videoActionPerformed(evt);
            }
        });

        button_info_audio.setText("View info");
        button_info_audio.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button_info_audioActionPerformed(evt);
            }
        });

        button_info_controls.setText("View info");
        button_info_controls.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button_info_controlsActionPerformed(evt);
            }
        });

        button_info_ingame.setText("View info");
        button_info_ingame.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button_info_ingameActionPerformed(evt);
            }
        });

        button_info_network.setText("View info");
        button_info_network.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button_info_networkActionPerformed(evt);
            }
        });

        button_info_other.setText("View info");
        button_info_other.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button_info_otherActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout plugins_panelLayout = new javax.swing.GroupLayout(plugins_panel);
        plugins_panel.setLayout(plugins_panelLayout);
        plugins_panelLayout.setHorizontalGroup(
            plugins_panelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(plugins_panelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(plugins_panelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(label_title_video, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(label_title_audio, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(label_title_controls, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(label_title_ingame, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(label_title_network, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(label_title_other, javax.swing.GroupLayout.Alignment.TRAILING))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(plugins_panelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(combobox_controls, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(combobox_audio, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(combobox_ingame, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(combobox_network, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(combobox_other, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(combobox_video, javax.swing.GroupLayout.PREFERRED_SIZE, 718, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(plugins_panelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(plugins_panelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(button_info_audio, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(button_info_video, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(button_info_controls)
                    .addComponent(button_info_ingame)
                    .addComponent(button_info_network)
                    .addComponent(button_info_other))
                .addContainerGap())
        );

        plugins_panelLayout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {button_info_controls, button_info_ingame, button_info_network, button_info_other, button_info_video});

        plugins_panelLayout.setVerticalGroup(
            plugins_panelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(plugins_panelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(plugins_panelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(label_title_video)
                    .addComponent(combobox_video, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(button_info_video))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(plugins_panelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(label_title_audio)
                    .addComponent(combobox_audio, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(button_info_audio))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(plugins_panelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(label_title_controls)
                    .addComponent(combobox_controls, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(button_info_controls))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(plugins_panelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(label_title_ingame)
                    .addComponent(combobox_ingame, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(button_info_ingame))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(plugins_panelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(label_title_network)
                    .addComponent(combobox_network, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(button_info_network))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(plugins_panelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(label_title_other)
                    .addComponent(combobox_other, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(button_info_other))
                .addContainerGap(16, Short.MAX_VALUE))
        );

        jLabel2.setText("Mednafen command format:");

        combobox_command_format.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "mednafen OPTIONS ROM (recommended for GNU/Linux and Apple Mac OS X)", "mednafen ROM OPTIONS (recommended for Microsoft Windows)" }));

        button_help_command_format.setText("?");
        button_help_command_format.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button_help_command_formatActionPerformed(evt);
            }
        });

        jLabel3.setText("Available extentions:");

        button_add_extention.setText("Add");
        button_add_extention.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button_add_extentionActionPerformed(evt);
            }
        });

        combobox_extentions.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(plugins_panel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel9Layout.createSequentialGroup()
                        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel3, javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel2, javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(label_binary_path, javax.swing.GroupLayout.Alignment.TRAILING))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(combobox_extentions, javax.swing.GroupLayout.Alignment.TRAILING, 0, 767, Short.MAX_VALUE)
                            .addComponent(combobox_command_format, 0, 767, Short.MAX_VALUE)
                            .addComponent(textfield_binary_path, javax.swing.GroupLayout.DEFAULT_SIZE, 767, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(button_help_command_format, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 51, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(button_add_extention, javax.swing.GroupLayout.Alignment.TRAILING))))
                .addContainerGap())
        );

        jPanel9Layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {button_add_extention, button_help_command_format});

        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(label_binary_path)
                    .addComponent(textfield_binary_path, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(combobox_command_format, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(button_help_command_format))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(button_add_extention)
                    .addComponent(combobox_extentions, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 9, Short.MAX_VALUE)
                .addComponent(plugins_panel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        tabbedpanel_plugins.addTab("JMednafen configuration", jPanel9);

        button_reload.setText("Reload config");
        button_reload.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button_reloadActionPerformed(evt);
            }
        });

        button_reset.setText("Reset default values");
        button_reset.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button_resetActionPerformed(evt);
            }
        });

        button_install_new_plugins.setText("Install new plugins");
        button_install_new_plugins.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                button_install_new_pluginsActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(label_icon)
                        .addGap(18, 18, 18)
                        .addComponent(label_title)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(button_reload)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(button_reset)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(button_install_new_plugins)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(button_save)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(button_close))
                    .addComponent(tabbedpanel_plugins))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {button_close, button_save});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(label_title)
                    .addComponent(label_icon))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(tabbedpanel_plugins)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(button_reload)
                    .addComponent(button_reset)
                    .addComponent(button_close)
                    .addComponent(button_save)
                    .addComponent(button_install_new_plugins))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void button_closeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button_closeActionPerformed
    setVisible ( false );
}//GEN-LAST:event_button_closeActionPerformed

    private void button_info_videoActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button_info_videoActionPerformed
        showInfo ( video_options , "Video plugin" );
    }//GEN-LAST:event_button_info_videoActionPerformed

    private void button_info_audioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button_info_audioActionPerformed
        showInfo ( audio_options , "Audio plugin" );
    }//GEN-LAST:event_button_info_audioActionPerformed

    private void button_info_controlsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button_info_controlsActionPerformed
        showInfo ( control_options , "Control plugin" );
    }//GEN-LAST:event_button_info_controlsActionPerformed

    private void button_info_ingameActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button_info_ingameActionPerformed
        showInfo ( ingame_options , "In-Game plugin" );
    }//GEN-LAST:event_button_info_ingameActionPerformed

    private void button_info_networkActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button_info_networkActionPerformed
        showInfo ( network_options , "Network plugin" );
    }//GEN-LAST:event_button_info_networkActionPerformed

    private void button_info_otherActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button_info_otherActionPerformed
        showInfo ( other_options , "Other plugin" );
    }//GEN-LAST:event_button_info_otherActionPerformed

    private void combobox_videoItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_combobox_videoItemStateChanged
        if ( can_reload_plugin_list )
        {
            configuration.setVideoPluginPath ( (String)combobox_video.getSelectedItem () );
            must_load_video = true;
            loadConfig ();
            must_load_video = false;
        }
    }//GEN-LAST:event_combobox_videoItemStateChanged

    private void combobox_audioItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_combobox_audioItemStateChanged
        if ( can_reload_plugin_list )
        {
            configuration.setAudioPluginPath ( (String)combobox_audio.getSelectedItem () );
            must_load_audio = true;
            loadConfig ();
            must_load_audio = false;
        }
    }//GEN-LAST:event_combobox_audioItemStateChanged

    private void combobox_controlsItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_combobox_controlsItemStateChanged
        if ( can_reload_plugin_list )
        {
            configuration.setControlPluginPath ( (String)combobox_controls.getSelectedItem () );
            must_load_control = true;
            loadConfig ();
            must_load_control = false;
        }
    }//GEN-LAST:event_combobox_controlsItemStateChanged

    private void combobox_ingameItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_combobox_ingameItemStateChanged
        if ( can_reload_plugin_list )
        {
            configuration.setInGamePluginPath ( (String)combobox_ingame.getSelectedItem () );
            must_load_ingame = true;
            loadConfig ();
            must_load_ingame = false;
        }
    }//GEN-LAST:event_combobox_ingameItemStateChanged

    private void combobox_networkItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_combobox_networkItemStateChanged
        if ( can_reload_plugin_list )
        {
            configuration.setNetworkPluginPath ( (String)combobox_network.getSelectedItem () );
            must_load_network = true;
            loadConfig ();
            must_load_network = false;
        }
    }//GEN-LAST:event_combobox_networkItemStateChanged

    private void combobox_otherItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_combobox_otherItemStateChanged
        if ( can_reload_plugin_list )
        {
            configuration.setOtherPluginPath ( (String)combobox_other.getSelectedItem () );
            must_load_other = true;
            loadConfig ();
            must_load_other = false;
        }
    }//GEN-LAST:event_combobox_otherItemStateChanged

    private void button_saveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button_saveActionPerformed
        saveOptions ();
    }//GEN-LAST:event_button_saveActionPerformed

    private void button_add_extentionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button_add_extentionActionPerformed
        String new_extention = JOptionPane.showInputDialog(this, "Enter the new extention to bring support." , "Add a new supported extention" , JOptionPane.OK_CANCEL_OPTION );
        
        if ( new_extention != null )
        {
            if ( !new_extention.isEmpty () && new_extention.length () >= 1 && !new_extention.equals ( "." ) )
            {
                String[] new_extentions;
                new_extentions = new String [ configuration.getExtentions ().length + 1 ];
                System.arraycopy(configuration.getExtentions (), 0, new_extentions, 0, configuration.getExtentions ().length);
                new_extentions[ configuration.getExtentions ().length ] = new_extention;
                configuration.setExtentions ( new_extentions );
                combobox_extentions.addItem ( new_extention );
            }
        }
    }//GEN-LAST:event_button_add_extentionActionPerformed

    private void button_help_command_formatActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button_help_command_formatActionPerformed
        JOptionPane.showMessageDialog ( this ,
                                        "Due to command format restrictions by Mednafen based on it's version,\nsometimes Mednafen need that the first argument be the ROM file name,\nand sometimes that does not matter.\n\nIf Mednafen don't run with the current configuration, try the other command format." ,
                                        "Why a command format?" ,
                                        JOptionPane.INFORMATION_MESSAGE
                                      );
    }//GEN-LAST:event_button_help_command_formatActionPerformed

    private void button_reloadActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button_reloadActionPerformed
        must_load_control = true;
        must_load_video = true;
        must_load_audio = true;
        must_load_ingame = true;
        must_load_network = true;
        must_load_other = true;
        must_load_internal_config = true;
        loadConfig ();
        must_load_control = false;
        must_load_video = false;
        must_load_audio = false;
        must_load_ingame = false;
        must_load_network = false;
        must_load_other = false;
        must_load_internal_config = false;
    }//GEN-LAST:event_button_reloadActionPerformed

    private void button_resetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button_resetActionPerformed
        for ( int i = 0; i < audio_options.getRows ().size (); i++ )
        {
            audio_options.getRows ().get ( i ).reset ();
        }
        
        for ( int i = 0; i < video_options.getRows ().size (); i++ )
        {
            video_options.getRows ().get ( i ).reset ();
        }
        
        for ( int i = 0; i < other_options.getRows ().size (); i++ )
        {
            other_options.getRows ().get ( i ).reset ();
        }
        
        for ( int i = 0; i < control_options.getRows ().size (); i++ )
        {
            control_options.getRows ().get ( i ).reset ();
        }
        
        for ( int i = 0; i < ingame_options.getRows ().size (); i++ )
        {
            ingame_options.getRows ().get ( i ).reset ();
        }
        
        for ( int i = 0; i < network_options.getRows ().size (); i++ )
        {
            network_options.getRows ().get ( i ).reset ();
        }
        
        configuration.reset ();
        
        just_reseting = true;
        
        showOptions ();
        
        just_reseting = false;
    }//GEN-LAST:event_button_resetActionPerformed

    private void button_install_new_pluginsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_button_install_new_pluginsActionPerformed
        installNewPlugins ();
    }//GEN-LAST:event_button_install_new_pluginsActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Config.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Config.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Config.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Config.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {

            @Override
            public void run() {
                new Config().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton button_add_extention;
    private javax.swing.JButton button_close;
    private javax.swing.JButton button_help_command_format;
    private javax.swing.JButton button_info_audio;
    private javax.swing.JButton button_info_controls;
    private javax.swing.JButton button_info_ingame;
    private javax.swing.JButton button_info_network;
    private javax.swing.JButton button_info_other;
    private javax.swing.JButton button_info_video;
    private javax.swing.JButton button_install_new_plugins;
    private javax.swing.JButton button_reload;
    private javax.swing.JButton button_reset;
    private javax.swing.JButton button_save;
    private javax.swing.JComboBox combobox_audio;
    private javax.swing.JComboBox combobox_command_format;
    private javax.swing.JComboBox combobox_controls;
    private javax.swing.JComboBox combobox_extentions;
    private javax.swing.JComboBox combobox_ingame;
    private javax.swing.JComboBox combobox_network;
    private javax.swing.JComboBox combobox_other;
    private javax.swing.JComboBox combobox_video;
    private javax.swing.JButton jButton13;
    private javax.swing.JComboBox jComboBox7;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JLabel label_binary_path;
    private javax.swing.JLabel label_icon;
    private javax.swing.JLabel label_title;
    private javax.swing.JLabel label_title_audio;
    private javax.swing.JLabel label_title_controls;
    private javax.swing.JLabel label_title_ingame;
    private javax.swing.JLabel label_title_network;
    private javax.swing.JLabel label_title_other;
    private javax.swing.JLabel label_title_video;
    private javax.swing.JPanel panel_audio;
    private javax.swing.JPanel panel_controls;
    private javax.swing.JPanel panel_ingame;
    private javax.swing.JPanel panel_network;
    private javax.swing.JPanel panel_other;
    private javax.swing.JPanel panel_video;
    private javax.swing.JPanel plugins_panel;
    private javax.swing.JTabbedPane tabbedpanel_plugins;
    private javax.swing.JTextField textfield_binary_path;
    // End of variables declaration//GEN-END:variables
}
