/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package jmednafen;

import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridLayout;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.UIManager;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 *
 * @author moises
 */
public class ConfigRow extends JPanel implements ChangeListener
{
    JPanel local_panel;
    private JLabel description;
    private JTextField value;
    private JCheckBox checkbox;
    private JComboBox combobox;
    private JTextField textfield;
    private JSlider slider;
    private String[] options;
    private String[] values;
    private String command;
    private int type;
    private int values_a;
    private int values_b;
    private boolean checkbox_default;
    private String other_default;
    private int slider_default;
    private boolean checkbox_actual;
    private String other_actual;
    private int slider_actual;
    
    public final static int SEPARATOR = 0;
    public final static int TITLE = 1;
    public final static int CHECKBOX = 2;
    public final static int COMBOBOX = 3;
    public final static int TEXTFIELD = 4;
    public final static int SLIDER = 5;
    public final static int CONDITIONAL_CHECKBOX = 6;
    
    public ConfigRow ( int new_type , String new_command )
    {
        setLayout ( new GridLayout ( 1 , 0 ) );
        description = new JLabel ();
        value = new JTextField ( 20 );
        value.setEditable ( false );
        value.setEnabled ( false );
        type = new_type;
        command = new_command;
        checkbox_default = true;
        checkbox = new JCheckBox ();
        combobox = new JComboBox ();
        textfield = new JTextField ( 30 );
        slider = new JSlider ();
        other_actual = new String ();
        other_default = "DummyValue";
        local_panel = new JPanel ();
        local_panel.setLayout ( new FlowLayout () );
    }
    
    public static ConfigRow createSeparator ()
    {
        return ( new ConfigRow ( ConfigRow.SEPARATOR , "Dummy" ) );
    }
    
    public int getType ()
    {
        return ( type );
    }
    
    public void setOptions ( String[] new_options )
    {
        options = new_options;
    }
    
    public void setValues ( String[] new_values )
    {
        values = new_values;
    }
    
    public void setValues ( int a , int b )
    {
        values_a = a;
        values_b = b;
    }
    
    public void config ()
    {
        int selected_index = 0;
        add ( description );
        
        switch ( type )
        {
            case SEPARATOR:
                            description.setText ( " " );
                            break;
            case TITLE:
                            description.setText ( description.getText ().toUpperCase () );
                            description.setFont( new Font ( UIManager.getDefaults ().getFont ( "TabbedPane.font" ).getFamily () , Font.BOLD , 14 ) );
                            break;
            case CHECKBOX:
                            add ( checkbox );
                            checkbox.setSelected ( checkbox_actual );
                            break;
            case COMBOBOX:
                            add ( combobox );
                            combobox.removeAllItems ();
                            for ( int i = 0; i < options.length; i++ )
                            {
                                combobox.addItem( options[ i ] );
                                if ( options[ i ].equals ( other_actual ) )
                                {
                                    selected_index = i;
                                }
                            }
                            combobox.setSelectedIndex ( selected_index );
                            break;
            case TEXTFIELD:
                            add ( textfield );
                            textfield.setText ( other_actual );
                            break;
            case SLIDER:
                            add ( local_panel );
                            local_panel.add ( slider );
                            slider.setMaximum ( values_b );
                            slider.setMinimum ( values_a );
                            slider.addChangeListener ( this );
                            slider.setValue ( slider_actual );
                            local_panel.add ( value );
                            value.setText ( "Value: " + Integer.toString ( slider.getValue () ) );
                            break;
            case CONDITIONAL_CHECKBOX:
                            add ( checkbox );
                            checkbox.setSelected ( checkbox_actual );
                            break;
            default:
                        break;
        }
    }
    
    public void setDescription ( String new_description )
    {
        description.setText ( new_description );
    }
    
    public void setDefaultValue ( boolean new_value )
    {
        checkbox_default = new_value;
        checkbox_actual = new_value;
    }
    
    public void setDefaultValue ( String new_value )
    {
        other_default = new_value;
        other_actual = new_value;
    }
    
    public void setDefaultValue ( int new_value )
    {
        slider_default = new_value;
        slider_actual = new_value;
        
    }
    
    public void setCurrentValue ( boolean new_value )
    {
        checkbox_actual = new_value;
    }
    
    public void setCurrentValue ( String new_value )
    {
        other_actual = new_value;
    }
    
    public void setCurrentValue ( int new_value )
    {
        slider_actual = new_value;
    }
    
    public String getCommand ()
    {
        String full_command = new String ();
        
        full_command = command;
        full_command += " ";
        
        switch ( type )
        {
            case CHECKBOX:
                            checkbox_actual = checkbox.isSelected ();
                            if ( Boolean.toString ( checkbox.isSelected () ).equals ( "true" ) )
                            {
                                full_command += "1";
                            }
                            else
                            {
                                full_command += "0";
                            }
                            break;
            case CONDITIONAL_CHECKBOX:
                            checkbox_actual = checkbox.isSelected ();
                            if ( !Boolean.toString ( checkbox.isSelected () ).equals ( "true" ) )
                            {
                                full_command = "";
                            }
                            break;
            case COMBOBOX:
                            other_actual = (String)combobox.getSelectedItem ();
                            full_command += "\"" + values[ combobox.getSelectedIndex () ] + "\"";
                            break;
            case TEXTFIELD:
                            other_actual = textfield.getText ();
                            full_command += "\"" + textfield.getText () + "\"";
                            break;
            case SLIDER:
                            slider_actual = slider.getValue ();
                            full_command += Integer.toString ( slider.getValue () );
                            break;
            default:
                        full_command = "";
                        break;
        }
        
        return ( full_command );
    }
    
    public void reset ()
    {
        switch ( type )
        {
            case CHECKBOX:
                            checkbox.setSelected ( checkbox_default );
                            break;
            case CONDITIONAL_CHECKBOX:
                            checkbox.setSelected ( checkbox_default );
                            break;
            case COMBOBOX:
                            for ( int i = 0; i < options.length; i++ )
                            {
                                if ( options[ i ].equals ( other_default ) )
                                {
                                    combobox.setSelectedIndex ( i );
                                }
                            }
                            break;
            case TEXTFIELD:
                            textfield.setText ( other_default );
                            break;
            case SLIDER:
                            slider.setValue ( slider_default );
                            break;
            default:
                        break;
        }
    }
    
    public String getCurrentValue ()
    {
        String value_local = new String ();
        
        switch ( type )
        {
            case SLIDER:
                            slider_actual = slider.getValue ();
                            value_local = Integer.toString ( slider_actual );
                            break;
            case CHECKBOX:
                            checkbox_actual = checkbox.isSelected ();
                            if ( checkbox_actual )
                            {
                                value_local = "1";
                            }
                            else
                            {
                                value_local = "0";
                            }
                            break;
            case CONDITIONAL_CHECKBOX:
                            checkbox_actual = checkbox.isSelected ();
                            if ( checkbox_actual )
                            {
                                value_local = "1";
                            }
                            else
                            {
                                value_local = "0";
                            }
                            break;
            case COMBOBOX:
                            other_actual = (String)combobox.getSelectedItem ();
                            value_local = other_actual;
                            break;
            case TEXTFIELD:
                            other_actual = textfield.getText ();
                            value_local = other_actual;
                            break;
            default:
                            value_local = other_default;
                            break;
        }
        
        return ( value_local );
    }
    
    public String getDefaultValue ()
    {
        String local_value = new String ();
        
        switch ( type )
        {
            case SLIDER:
                            local_value = Integer.toString ( slider_default );
                            break;
            case CHECKBOX:
                            if ( checkbox_default )
                            {
                                local_value = "1";
                            }
                            else
                            {
                                local_value = "0";
                            }
                            break;
            case CONDITIONAL_CHECKBOX:
                            if ( checkbox_default )
                            {
                                local_value = "1";
                            }
                            else
                            {
                                local_value = "0";
                            }
                            break;
            case COMBOBOX:
                            local_value = other_default;
                            break;
            case TEXTFIELD:
                            local_value = other_default;
                            break;
            default:
                            local_value = other_default;
                            break;
        }
        
        return ( local_value );
    }

    @Override
    public void stateChanged ( ChangeEvent ce )
    {
        value.setText ( "Value: " + Integer.toString ( slider.getValue () ) );
    }
}
