package jmednafen;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import javax.swing.JOptionPane;

/**
 *
 * @author moises
 */
public class FileCreator implements PluginNames , PluginVersions
{
    public static final int CREATE = 1;
    public static final int SAVE = 2;
    
    public static boolean createPluginVideo ( int mednafen_version )
    {
        
        return ( true );
    }
    
    public static boolean createLauncherScript ( String command , String file_path )
    {
        PrintWriter output_file;
        
        File file = new File ( file_path );
        if ( file.isFile () )
        {
            if ( !file.delete () )
            {
                JOptionPane.showMessageDialog ( null , "Error delte previous launch script: " + file_path + ". Mednafen can't be executed." , "Error launching Mednafen", JOptionPane.ERROR_MESSAGE );
                return ( false );
            }
        }
        
        try
        {
            output_file = new PrintWriter ( new FileWriter ( file_path ) );
        }
        catch ( IOException e )
        {
            JOptionPane.showMessageDialog ( null , "Error creating launch script: " + file_path + ". Mednafen can't be executed." , "Error launching Mednafen", JOptionPane.ERROR_MESSAGE );
            return ( false );
        }
        
        if ( File.separator.equals ( "/" ) )
        {
            output_file.println ( "#!/bin/bash" );
        }
        
        output_file.println ( command );
        
        output_file.close ();
        
        return ( true );
    }
    
    public static void createStoredValuesFile ( String file_path , ArrayList<ConfigRow> options , int mode )
    {
        PrintWriter output_file;
        
        if ( mode == SAVE )
        {
            File file = new File ( file_path + ".sav" );
            if ( file.isFile () )
            {
                file.delete ();
            }
        }
        
        try
        {
            output_file = new PrintWriter ( new FileWriter ( file_path + ".sav" ) );
        }
        catch ( IOException e )
        {
            System.out.println ( "Error creating saved values file: " + file_path + ".sav" );
            return;
        }
        
        for ( int i = 0; i < options.size (); i++ )
        {
            if ( mode == CREATE )
            {
                output_file.println ( options.get ( i ).getDefaultValue () );
            }
            else if ( mode == SAVE )
            {
                output_file.println ( options.get ( i ).getCurrentValue () );
            }
        }
        
        output_file.close ();
    }
    
    public static void createPluginFile ( String file_path , int type )
    {
        
        switch ( type )
        {
            case FileLoader.VIDEO:
                                    PluginCreator.makeVideoPlugin ( file_path, MEDNAFEN_MAX );
                                    break;
            case FileLoader.AUDIO:
                                    PluginCreator.makeAudioPlugin ( file_path, MEDNAFEN_MAX );
                                    break;
            case FileLoader.OTHER:
                                    PluginCreator.makeOtherPlugin ( file_path, MEDNAFEN_MAX );
                                    break;
            case FileLoader.CONTROL:
                                    PluginCreator.makeControlsPlugin ( file_path, MEDNAFEN_MAX );
                                    break;
            case FileLoader.INGAME:
                                    PluginCreator.makeInGamePlugin ( file_path, MEDNAFEN_MAX );
                                    break;
            case FileLoader.NETWORK:
                                    PluginCreator.makeNetworkPlugin ( file_path, MEDNAFEN_MAX );
                                    break;
        }
    }
    
    public static void checkDefaultAudioPlugins ( String plugin_path )
    {
        File file;
        
        file = new File ( plugin_path + AUDIO_0_9_21 );
        if ( !file.isFile () )
        {
            PluginCreator.makeAudioPlugin ( plugin_path , MEDNAFEN_0_9_21 );
        }
        
        file = new File ( plugin_path + AUDIO_0_8_D );
        if ( !file.isFile () )
        {
            PluginCreator.makeAudioPlugin ( plugin_path , MEDNAFEN_0_8_D );
        }
    }
    
    public static void checkDefaultVideoPlugins ( String plugin_path )
    {
        File file;
        
        file = new File ( plugin_path + VIDEO_0_9_21 );
        if ( !file.isFile () )
        {
            PluginCreator.makeVideoPlugin ( plugin_path , MEDNAFEN_0_9_21 );
        }
        
        file = new File ( plugin_path + VIDEO_0_8_D );
        if ( !file.isFile () )
        {
            PluginCreator.makeVideoPlugin ( plugin_path , MEDNAFEN_0_8_D );
        }
    }
    
    public static void checkDefaultControlsPlugins ( String plugin_path )
    {
        File file;
        
        file = new File ( plugin_path + CONTROLS_0_9_21 );
        if ( !file.isFile () )
        {
            PluginCreator.makeControlsPlugin ( plugin_path , MEDNAFEN_0_9_21 );
        }
        
        file = new File ( plugin_path + CONTROLS_0_8_D );
        if ( !file.isFile () )
        {
            PluginCreator.makeControlsPlugin ( plugin_path , MEDNAFEN_0_8_D );
        }
    }
    
    public static void checkDefaultInGamePlugins ( String plugin_path )
    {
        File file;
        
        file = new File ( plugin_path + INGAME_0_9_21 );
        if ( !file.isFile () )
        {
            PluginCreator.makeInGamePlugin ( plugin_path , MEDNAFEN_0_9_21 );
        }
        
        file = new File ( plugin_path + INGAME_0_8_D );
        if ( !file.isFile () )
        {
            PluginCreator.makeInGamePlugin ( plugin_path , MEDNAFEN_0_8_D );
        }
    }
    
    public static void checkDefaultNetworkPlugins ( String plugin_path )
    {
        File file;
        
        file = new File ( plugin_path + NETWORK_0_9_21 );
        if ( !file.isFile () )
        {
            PluginCreator.makeNetworkPlugin ( plugin_path , MEDNAFEN_0_9_21 );
        }
        
        file = new File ( plugin_path + NETWORK_0_8_D );
        if ( !file.isFile () )
        {
            PluginCreator.makeNetworkPlugin ( plugin_path , MEDNAFEN_0_8_D );
        }
    }
    
    public static void checkDefaultOtherPlugins ( String plugin_path )
    {
        File file;
        
        file = new File ( plugin_path + OTHER_0_9_21 );
        if ( !file.isFile () )
        {
            PluginCreator.makeOtherPlugin ( plugin_path , MEDNAFEN_0_9_21 );
        }
        
        file = new File ( plugin_path + OTHER_0_8_D );
        if ( !file.isFile () )
        {
            PluginCreator.makeOtherPlugin ( plugin_path , MEDNAFEN_0_8_D );
        }
    }
    
    public static void createInternalConfiguration ( String file_path , int mode , InternalConfiguration config )
    {
        if ( mode == SAVE )
        {
            File file = new File ( file_path );
            if ( file.isFile () )
            {
                file.delete ();
            }
        }
        
        PrintWriter output_file;
        
        try
        {
            output_file = new PrintWriter ( new FileWriter ( file_path ) );
        }
        catch ( IOException e )
        {
            JOptionPane.showMessageDialog ( null , "Error creating new internal configuration (JMednafen) file" + file_path + ". Try restarting the application." , "Error creating configuration" , JOptionPane.ERROR_MESSAGE );
            return;
        }
        
        if ( mode == CREATE )
        {
            output_file.println ( "Audio::" + AUDIO_LATEST );
            output_file.println ( "Video::" + VIDEO_LATEST );
            output_file.println ( "Other::" + OTHER_LATEST );
            output_file.println ( "Control::" + CONTROLS_LATEST );
            output_file.println ( "InGame::" + INGAME_LATEST );
            output_file.println ( "Network::" + NETWORK_LATEST );
            output_file.println ( "Extentions::lnx:pce:cue:ngp:ngc:ngp:gb:gbc:sgb:gba:nes:gg:smd:md:bin:sms:smc:fig:sfc:vb:ws:wsc" );
            output_file.println ( "MednafenPath::mednafen" );
            output_file.println ( "# CommandFormat values (for 0.2.1 version of JMednafen and above):" );
            output_file.println ( "# 0 - mednafen OPTIONS ROM" );
            output_file.println ( "# 1 - mednafen ROM OPTIONS" );
            if ( File.separator.equals ( "/" ) )
            {
                output_file.println ( "CommandFormat::0" );
            }
            else
            {
                output_file.println ( "CommandFormat::1" );
            }
        }
        else
        {
            output_file.println ( "Audio::" + config.getAudioPluginPath () );
            output_file.println ( "Video::" + config.getVideoPluginPath () );
            output_file.println ( "Other::" + config.getOtherPluginPath () );
            output_file.println ( "Control::" + config.getControlPluginPath () );
            output_file.println ( "InGame::" + config.getInGamePluginPath () );
            output_file.println ( "Network::" + config.getNetworkPluginPath () );
            output_file.print ( "Extentions:" );
            for ( int i = 0; i < config.getExtentions ().length; i++ )
            {
                output_file.print ( ":" + config.getExtentions ()[ i ] );
            }
            if ( config.getExtentions ().length == 0 )
            {
                output_file.println ( ":lnx:pce:cue:ngp:ngc:ngp:gb:gbc:sgb:gba:nes:gg:smd:md:bin:sms:smc:fig:sfc:vb:ws:wsc" );
            }
            else
            {
                output_file.println ( "" );
            }
            output_file.println ( "MednafenPath::" + config.getMednafenPath () );
            output_file.println ( "# CommandFormat values (for 0.2.1 version of JMednafen):" );
            output_file.println ( "# 0 - mednafen OPTIONS ROM" );
            output_file.println ( "# 1 - mednafen ROM OPTIONS" );
            output_file.println ( "CommandFormat::" + Integer.toString ( config.getCommandFormat () ) );
        }
        
        output_file.close ();
    }
}
